Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4723)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4724)
@@ -1959,36 +2756,36 @@
 !--    access. Dummy arrays will be allocated with dimension length zero.
        IF ( bc_dirichlet_n )  THEN
-          ALLOCATE( nest_offl%u_north(0:1,nzb+1:nzt,nxlu:nxr) )
-          ALLOCATE( nest_offl%v_north(0:1,nzb+1:nzt,nxl:nxr)  )
-          ALLOCATE( nest_offl%w_north(0:1,nzb+1:nzt-1,nxl:nxr) )
-          IF ( humidity )       ALLOCATE( nest_offl%q_north(0:1,nzb+1:nzt,nxl:nxr)  )
-          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_north(0:1,nzb+1:nzt,nxl:nxr) )
+          ALLOCATE( nest_offl%u_n(0:1,nzb+1:nzt,i_start_u:i_end) )
+          ALLOCATE( nest_offl%v_n(0:1,nzb+1:nzt,i_start:i_end)  )
+          ALLOCATE( nest_offl%w_n(0:1,nzb+1:nzt-1,i_start:i_end) )
+          IF ( humidity )       ALLOCATE( nest_offl%q_n(0:1,nzb+1:nzt,i_start:i_end)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_n(0:1,nzb+1:nzt,i_start:i_end) )
           IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
-             ALLOCATE( nest_offl%chem_north(0:1,nzb+1:nzt,nxl:nxr,1:UBOUND( chem_species, 1 )) )
+             ALLOCATE( nest_offl%chem_n(0:1,nzb+1:nzt,i_start:i_end,1:UBOUND( chem_species, 1 )) )
        ELSE
-          ALLOCATE( nest_offl%u_north(1:1,1:1,1:1)  )
-          ALLOCATE( nest_offl%v_north(1:1,1:1,1:1)  )
-          ALLOCATE( nest_offl%w_north(1:1,1:1,1:1)  )
-          IF ( humidity )       ALLOCATE( nest_offl%q_north(1:1,1:1,1:1)  )
-          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_north(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%u_n(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%v_n(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%w_n(1:1,1:1,1:1)  )
+          IF ( humidity )       ALLOCATE( nest_offl%q_n(1:1,1:1,1:1)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_n(1:1,1:1,1:1)  )
           IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
-             ALLOCATE( nest_offl%chem_north(1:1,1:1,1:1,1:UBOUND( chem_species, 1 )) )
+             ALLOCATE( nest_offl%chem_n(1:1,1:1,1:1,1:UBOUND( chem_species, 1 )) )
        ENDIF
        IF ( bc_dirichlet_s )  THEN
-          ALLOCATE( nest_offl%u_south(0:1,nzb+1:nzt,nxlu:nxr) )
-          ALLOCATE( nest_offl%v_south(0:1,nzb+1:nzt,nxl:nxr)  )
-          ALLOCATE( nest_offl%w_south(0:1,nzb+1:nzt-1,nxl:nxr)    )
-          IF ( humidity )       ALLOCATE( nest_offl%q_south(0:1,nzb+1:nzt,nxl:nxr)  )
-          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_south(0:1,nzb+1:nzt,nxl:nxr) )
+          ALLOCATE( nest_offl%u_s(0:1,nzb+1:nzt,i_start_u:i_end) )
+          ALLOCATE( nest_offl%v_s(0:1,nzb+1:nzt,i_start:i_end)  )
+          ALLOCATE( nest_offl%w_s(0:1,nzb+1:nzt-1,i_start:i_end) )
+          IF ( humidity )       ALLOCATE( nest_offl%q_s(0:1,nzb+1:nzt,i_start:i_end)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_s(0:1,nzb+1:nzt,i_start:i_end) )
           IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
-             ALLOCATE( nest_offl%chem_south(0:1,nzb+1:nzt,nxl:nxr,1:UBOUND( chem_species, 1 )) )
+             ALLOCATE( nest_offl%chem_s(0:1,nzb+1:nzt,i_start:i_end,1:UBOUND( chem_species, 1 )) )
        ELSE
-          ALLOCATE( nest_offl%u_south(1:1,1:1,1:1)  )
-          ALLOCATE( nest_offl%v_south(1:1,1:1,1:1)  )
-          ALLOCATE( nest_offl%w_south(1:1,1:1,1:1)  )
-          IF ( humidity )       ALLOCATE( nest_offl%q_south(1:1,1:1,1:1)  )
-          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_south(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%u_s(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%v_s(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%w_s(1:1,1:1,1:1)  )
+          IF ( humidity )       ALLOCATE( nest_offl%q_s(1:1,1:1,1:1)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_s(1:1,1:1,1:1)  )
           IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
-             ALLOCATE( nest_offl%chem_south(1:1,1:1,1:1,1:UBOUND( chem_species, 1 )) )
+             ALLOCATE( nest_offl%chem_s(1:1,1:1,1:1,1:UBOUND( chem_species, 1 )) )
        ENDIF
 !
@@ -1996,11 +2793,21 @@
 !--    lateral boundaries, every core reads these data so that no dummy
 !--    arrays need to be allocated.
-       ALLOCATE( nest_offl%u_top(0:1,nys:nyn,nxlu:nxr) )
-       ALLOCATE( nest_offl%v_top(0:1,nysv:nyn,nxl:nxr) )
-       ALLOCATE( nest_offl%w_top(0:1,nys:nyn,nxl:nxr)  )
-       IF ( humidity )       ALLOCATE( nest_offl%q_top(0:1,nys:nyn,nxl:nxr)  )
-       IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_top(0:1,nys:nyn,nxl:nxr) )
-       IF ( air_chemistry  .AND.  nesting_offline_chem )                                           &
-          ALLOCATE( nest_offl%chem_top(0:1,nys:nyn,nxl:nxr,1:UBOUND( chem_species, 1 )) )
+       IF ( lod == 2 )  THEN
+          ALLOCATE( nest_offl%u_top(0:1,nys:nyn,nxlu:nxr) )
+          ALLOCATE( nest_offl%v_top(0:1,nysv:nyn,nxl:nxr) )
+          ALLOCATE( nest_offl%w_top(0:1,nys:nyn,nxl:nxr)  )
+          IF ( humidity )       ALLOCATE( nest_offl%q_top(0:1,nys:nyn,nxl:nxr)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_top(0:1,nys:nyn,nxl:nxr) )
+          IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
+             ALLOCATE( nest_offl%chem_top(0:1,nys:nyn,nxl:nxr,1:UBOUND( chem_species, 1 )) )
+       ELSE
+          ALLOCATE( nest_offl%u_top(0:1,1:1,1:1) )
+          ALLOCATE( nest_offl%v_top(0:1,1:1,1:1) )
+          ALLOCATE( nest_offl%w_top(0:1,1:1,1:1)  )
+          IF ( humidity )       ALLOCATE( nest_offl%q_top(0:1,1:1,1:1)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_top(0:1,1:1,1:1) )
+          IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
+             ALLOCATE( nest_offl%chem_top(0:1,1:1,1:1,1:UBOUND( chem_species, 1 )) )
+       ENDIF
 !
 !--    For chemical species, create the names of the variables. This is necessary
@@ -2067,72 +2874,218 @@
        ENDIF
 !
+!--    Set indicies for boundary grid points
+       IF ( bc_dirichlet_l  .OR.  bc_dirichlet_r )  THEN
+          i_bound   = MERGE( nxl  - 1, nxr + 1, bc_dirichlet_l )
+          i_bound_u = MERGE( nxlu - 1, nxr + 1, bc_dirichlet_l )
+       ENDIF
+       IF ( bc_dirichlet_n  .OR.  bc_dirichlet_s )  THEN
+          j_bound   = MERGE( nys  - 1, nyn + 1, bc_dirichlet_s )
+          j_bound_v = MERGE( nysv - 1, nyn + 1, bc_dirichlet_s )
+       ENDIF
+!
 !--    Initialize boundary data. Please note, do not initialize boundaries in 
 !--    case of restart runs. This case the boundaries are already initialized
-!--    and the boundary data from file would be on the wrong time level.  
+!--    and the boundary data from file would be on the wrong time level.
        IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-          IF ( bc_dirichlet_l )  THEN
-             u(nzb+1:nzt,nys:nyn,0)    = nest_offl%u_left(0,nzb+1:nzt,nys:nyn)
-             v(nzb+1:nzt,nysv:nyn,-1)  = nest_offl%v_left(0,nzb+1:nzt,nysv:nyn) 
-             w(nzb+1:nzt-1,nys:nyn,-1) = nest_offl%w_left(0,nzb+1:nzt-1,nys:nyn)
-             IF ( .NOT. neutral )  pt(nzb+1:nzt,nys:nyn,-1) =                  &
-                                      nest_offl%pt_left(0,nzb+1:nzt,nys:nyn)
-             IF ( humidity      )  q(nzb+1:nzt,nys:nyn,-1)  =                  &
-                                      nest_offl%q_left(0,nzb+1:nzt,nys:nyn)
+!
+!--       Distinguish between LOD = 1 and LOD = 2 inititialization
+          IF ( lod == 2 )  THEN
+             IF ( bc_dirichlet_l )  THEN
+                u(nzb+1:nzt,nys:nyn,i_bound_u) = nest_offl%u_l(0,nzb+1:nzt,nys:nyn)
+                v(nzb+1:nzt,nysv:nyn,i_bound)  = nest_offl%v_l(0,nzb+1:nzt,nysv:nyn) 
+                w(nzb+1:nzt-1,nys:nyn,i_bound) = nest_offl%w_l(0,nzb+1:nzt-1,nys:nyn)
+                IF ( .NOT. neutral )  pt(nzb+1:nzt,nys:nyn,i_bound) = nest_offl%pt_l(0,nzb+1:nzt,nys:nyn)
+                IF ( humidity      )  q(nzb+1:nzt,nys:nyn,i_bound)  = nest_offl%q_l(0,nzb+1:nzt,nys:nyn)
+                IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                   DO  n = 1, UBOUND( chem_species, 1 )
+                      IF( nest_offl%chem_from_file_l(n) )  THEN
+                         chem_species(n)%conc(nzb+1:nzt,nys:nyn,i_bound) = nest_offl%chem_l(0,nzb+1:nzt,nys:nyn,n)
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDIF
+             IF ( bc_dirichlet_r )  THEN
+                u(nzb+1:nzt,nys:nyn,i_bound_u) = nest_offl%u_r(0,nzb+1:nzt,nys:nyn)
+                v(nzb+1:nzt,nysv:nyn,i_bound)  = nest_offl%v_r(0,nzb+1:nzt,nysv:nyn) 
+                w(nzb+1:nzt-1,nys:nyn,i_bound) = nest_offl%w_r(0,nzb+1:nzt-1,nys:nyn)
+                IF ( .NOT. neutral )  pt(nzb+1:nzt,nys:nyn,i_bound) = nest_offl%pt_r(0,nzb+1:nzt,nys:nyn)
+                IF ( humidity      )  q(nzb+1:nzt,nys:nyn,i_bound)  = nest_offl%q_r(0,nzb+1:nzt,nys:nyn)
+                IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                   DO  n = 1, UBOUND( chem_species, 1 )
+                      IF( nest_offl%chem_from_file_r(n) )  THEN
+                         chem_species(n)%conc(nzb+1:nzt,nys:nyn,i_bound) = nest_offl%chem_r(0,nzb+1:nzt,nys:nyn,n)
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDIF
+
+             IF ( bc_dirichlet_n)  THEN
+                u(nzb+1:nzt,j_bound,nxlu:nxr)  = nest_offl%u_n(0,nzb+1:nzt,nxlu:nxr)
+                v(nzb+1:nzt,j_bound_v,nxl:nxr) = nest_offl%v_n(0,nzb+1:nzt,nxl:nxr) 
+                w(nzb+1:nzt-1,j_bound,nxl:nxr) = nest_offl%w_n(0,nzb+1:nzt-1,nxl:nxr) 
+                IF ( .NOT. neutral )  pt(nzb+1:nzt,j_bound,nxl:nxr) = nest_offl%pt_n(0,nzb+1:nzt,nxl:nxr)
+                IF ( humidity      )  q(nzb+1:nzt,j_bound,nxl:nxr)  = nest_offl%q_n(0,nzb+1:nzt,nxl:nxr) 
+                IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                   DO  n = 1, UBOUND( chem_species, 1 )
+                      IF( nest_offl%chem_from_file_n(n) )  THEN
+                         chem_species(n)%conc(nzb+1:nzt,j_bound,nxl:nxr) = nest_offl%chem_n(0,nzb+1:nzt,nxl:nxr,n)
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDIF
+             IF ( bc_dirichlet_s)  THEN
+                u(nzb+1:nzt,j_bound,nxlu:nxr)  = nest_offl%u_s(0,nzb+1:nzt,nxlu:nxr)
+                v(nzb+1:nzt,j_bound_v,nxl:nxr) = nest_offl%v_s(0,nzb+1:nzt,nxl:nxr) 
+                w(nzb+1:nzt-1,j_bound,nxl:nxr) = nest_offl%w_s(0,nzb+1:nzt-1,nxl:nxr) 
+                IF ( .NOT. neutral )  pt(nzb+1:nzt,j_bound,nxl:nxr) = nest_offl%pt_s(0,nzb+1:nzt,nxl:nxr)
+                IF ( humidity      )  q(nzb+1:nzt,j_bound,nxl:nxr)  = nest_offl%q_s(0,nzb+1:nzt,nxl:nxr) 
+                IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                   DO  n = 1, UBOUND( chem_species, 1 )
+                      IF( nest_offl%chem_from_file_s(n) )  THEN
+                         chem_species(n)%conc(nzb+1:nzt,j_bound,nxl:nxr) = nest_offl%chem_s(0,nzb+1:nzt,nxl:nxr,n)
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDIF
+
+             u(nzt+1,nys:nyn,nxlu:nxr) = nest_offl%u_top(0,nys:nyn,nxlu:nxr)
+             v(nzt+1,nysv:nyn,nxl:nxr) = nest_offl%v_top(0,nysv:nyn,nxl:nxr)
+             w(nzt,nys:nyn,nxl:nxr)    = nest_offl%w_top(0,nys:nyn,nxl:nxr)
+             w(nzt+1,nys:nyn,nxl:nxr)  = nest_offl%w_top(0,nys:nyn,nxl:nxr)
+             IF ( .NOT. neutral )  pt(nzt+1,nys:nyn,nxl:nxr) = nest_offl%pt_top(0,nys:nyn,nxl:nxr)
+             IF ( humidity )       q(nzt+1,nys:nyn,nxl:nxr)  = nest_offl%q_top(0,nys:nyn,nxl:nxr)
              IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
                 DO  n = 1, UBOUND( chem_species, 1 )
-                   IF( nest_offl%chem_from_file_l(n) )  THEN
-                      chem_species(n)%conc(nzb+1:nzt,nys:nyn,-1) =             &
-                                      nest_offl%chem_left(0,nzb+1:nzt,nys:nyn,n)
+                   IF( nest_offl%chem_from_file_t(n) )  THEN
+                      chem_species(n)%conc(nzt+1,nys:nyn,nxl:nxr) = nest_offl%chem_top(0,nys:nyn,nxl:nxr,n)
                    ENDIF
                 ENDDO
              ENDIF
-          ENDIF
-          IF ( bc_dirichlet_r )  THEN
-             u(nzb+1:nzt,nys:nyn,nxr+1)   = nest_offl%u_right(0,nzb+1:nzt,nys:nyn) 
-             v(nzb+1:nzt,nysv:nyn,nxr+1)  = nest_offl%v_right(0,nzb+1:nzt,nysv:nyn)
-             w(nzb+1:nzt-1,nys:nyn,nxr+1) = nest_offl%w_right(0,nzb+1:nzt-1,nys:nyn)
-             IF ( .NOT. neutral )  pt(nzb+1:nzt,nys:nyn,nxr+1) =               &
-                                      nest_offl%pt_right(0,nzb+1:nzt,nys:nyn)
-             IF ( humidity      )  q(nzb+1:nzt,nys:nyn,nxr+1)  =               &
-                                      nest_offl%q_right(0,nzb+1:nzt,nys:nyn)
+!
+!--       LOD 1
+          ELSE
+             IF ( bc_dirichlet_l )  THEN
+                DO  j = nys, nyn
+                   u(nzb+1:nzt,j,i_bound_u) = nest_offl%u_l(0,nzb+1:nzt,1)
+                   w(nzb+1:nzt-1,j,i_bound) = nest_offl%w_l(0,nzb+1:nzt-1,1)
+                ENDDO
+                DO  j = nysv, nyn
+                   v(nzb+1:nzt,j,i_bound)  = nest_offl%v_l(0,nzb+1:nzt,1) 
+                ENDDO
+                IF ( .NOT. neutral )  THEN
+                   DO  j = nys, nyn
+                      pt(nzb+1:nzt,j,i_bound) = nest_offl%pt_l(0,nzb+1:nzt,1)
+                   ENDDO
+                ENDIF
+                IF ( humidity      )  THEN
+                   DO  j = nys, nyn
+                      q(nzb+1:nzt,j,i_bound)  = nest_offl%q_l(0,nzb+1:nzt,1)
+                   ENDDO
+                ENDIF
+                IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                   DO  n = 1, UBOUND( chem_species, 1 )
+                      IF( nest_offl%chem_from_file_l(n) )  THEN
+                         DO  j = nys, nyn 
+                            chem_species(n)%conc(nzb+1:nzt,j,i_bound) = nest_offl%chem_l(0,nzb+1:nzt,1,n)
+                         ENDDO
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDIF
+             IF ( bc_dirichlet_r )  THEN
+                DO  j = nys, nyn
+                   u(nzb+1:nzt,j,i_bound_u) = nest_offl%u_r(0,nzb+1:nzt,1)
+                   w(nzb+1:nzt-1,j,i_bound) = nest_offl%w_r(0,nzb+1:nzt-1,1)
+                ENDDO
+                DO  j = nysv, nyn
+                   v(nzb+1:nzt,j,i_bound)  = nest_offl%v_r(0,nzb+1:nzt,1) 
+                ENDDO
+                IF ( .NOT. neutral )  THEN
+                   DO  j = nys, nyn
+                      pt(nzb+1:nzt,j,i_bound) = nest_offl%pt_r(0,nzb+1:nzt,1)
+                   ENDDO
+                ENDIF
+                IF ( humidity      )  THEN
+                   DO  j = nys, nyn
+                      q(nzb+1:nzt,j,i_bound)  = nest_offl%q_r(0,nzb+1:nzt,1)
+                   ENDDO
+                ENDIF
+                IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                   DO  n = 1, UBOUND( chem_species, 1 )
+                      IF( nest_offl%chem_from_file_r(n) )  THEN
+                         DO  j = nys, nyn 
+                            chem_species(n)%conc(nzb+1:nzt,j,i_bound) = nest_offl%chem_r(0,nzb+1:nzt,1,n)
+                         ENDDO
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDIF
+             IF ( bc_dirichlet_n )  THEN
+                DO  i = nxlu, nxr
+                   u(nzb+1:nzt,j_bound,i)  = nest_offl%u_n(0,nzb+1:nzt,1)
+                ENDDO
+                DO  i = nxl, nxr
+                   v(nzb+1:nzt,j_bound_v,i) = nest_offl%v_n(0,nzb+1:nzt,1) 
+                   w(nzb+1:nzt-1,j_bound,i) = nest_offl%w_n(0,nzb+1:nzt-1,1)
+                ENDDO
+                IF ( .NOT. neutral )  THEN
+                   DO  i = nxl, nxr
+                      pt(nzb+1:nzt,j_bound,i) = nest_offl%pt_n(0,nzb+1:nzt,1)
+                   ENDDO
+                ENDIF
+                IF ( humidity      )  THEN
+                   DO  i = nxl, nxr
+                      q(nzb+1:nzt,j_bound,i)  = nest_offl%q_n(0,nzb+1:nzt,1)
+                   ENDDO
+                ENDIF
+                IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                   DO  n = 1, UBOUND( chem_species, 1 )
+                      IF( nest_offl%chem_from_file_n(n) )  THEN
+                         DO  i = nxl, nxr
+                            chem_species(n)%conc(nzb+1:nzt,j_bound,i) = nest_offl%chem_n(0,nzb+1:nzt,1,n)
+                         ENDDO
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDIF
+             IF ( bc_dirichlet_s )  THEN
+                DO  i = nxlu, nxr
+                   u(nzb+1:nzt,j_bound,i)  = nest_offl%u_s(0,nzb+1:nzt,1)
+                ENDDO
+                DO  i = nxl, nxr
+                   v(nzb+1:nzt,j_bound_v,i) = nest_offl%v_s(0,nzb+1:nzt,1) 
+                   w(nzb+1:nzt-1,j_bound,i) = nest_offl%w_s(0,nzb+1:nzt-1,1)
+                ENDDO
+                IF ( .NOT. neutral )  THEN
+                   DO  i = nxl, nxr
+                      pt(nzb+1:nzt,j_bound,i) = nest_offl%pt_s(0,nzb+1:nzt,1)
+                   ENDDO
+                ENDIF
+                IF ( humidity      )  THEN
+                   DO  i = nxl, nxr
+                      q(nzb+1:nzt,j_bound,i)  = nest_offl%q_s(0,nzb+1:nzt,1)
+                   ENDDO
+                ENDIF
+                IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                   DO  n = 1, UBOUND( chem_species, 1 )
+                      IF( nest_offl%chem_from_file_s(n) )  THEN
+                         DO  i = nxl, nxr
+                            chem_species(n)%conc(nzb+1:nzt,j_bound,i) = nest_offl%chem_s(0,nzb+1:nzt,1,n)
+                         ENDDO
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDIF
+
+             u(nzt+1,nys:nyn,nxlu:nxr) = nest_offl%u_top(0,1,1)
+             v(nzt+1,nysv:nyn,nxl:nxr) = nest_offl%v_top(0,1,1)
+             w(nzt,nys:nyn,nxl:nxr)    = nest_offl%w_top(0,1,1)
+             w(nzt+1,nys:nyn,nxl:nxr)  = nest_offl%w_top(0,1,1)
+             IF ( .NOT. neutral )  pt(nzt+1,nys:nyn,nxl:nxr) = nest_offl%pt_top(0,1,1)
+             IF ( humidity )       q(nzt+1,nys:nyn,nxl:nxr)  = nest_offl%q_top(0,1,1)
              IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
                 DO  n = 1, UBOUND( chem_species, 1 )
-                   IF( nest_offl%chem_from_file_r(n) )  THEN
-                      chem_species(n)%conc(nzb+1:nzt,nys:nyn,nxr+1) =          &
-                                      nest_offl%chem_right(0,nzb+1:nzt,nys:nyn,n)
-                   ENDIF
-                ENDDO
-             ENDIF
-          ENDIF
-          IF ( bc_dirichlet_s )  THEN
-             u(nzb+1:nzt,-1,nxlu:nxr)  = nest_offl%u_south(0,nzb+1:nzt,nxlu:nxr)
-             v(nzb+1:nzt,0,nxl:nxr)    = nest_offl%v_south(0,nzb+1:nzt,nxl:nxr) 
-             w(nzb+1:nzt-1,-1,nxl:nxr) = nest_offl%w_south(0,nzb+1:nzt-1,nxl:nxr) 
-             IF ( .NOT. neutral )  pt(nzb+1:nzt,-1,nxl:nxr) =                  &
-                                      nest_offl%pt_south(0,nzb+1:nzt,nxl:nxr)
-             IF ( humidity      )  q(nzb+1:nzt,-1,nxl:nxr)  =                  &
-                                      nest_offl%q_south(0,nzb+1:nzt,nxl:nxr) 
-             IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-                DO  n = 1, UBOUND( chem_species, 1 )
-                   IF( nest_offl%chem_from_file_s(n) )  THEN
-                      chem_species(n)%conc(nzb+1:nzt,-1,nxl:nxr) =             &
-                                      nest_offl%chem_south(0,nzb+1:nzt,nxl:nxr,n)
-                   ENDIF
-                ENDDO
-             ENDIF
-          ENDIF
-          IF ( bc_dirichlet_n )  THEN
-             u(nzb+1:nzt,nyn+1,nxlu:nxr)  = nest_offl%u_north(0,nzb+1:nzt,nxlu:nxr)
-             v(nzb+1:nzt,nyn+1,nxl:nxr)   = nest_offl%v_north(0,nzb+1:nzt,nxl:nxr) 
-             w(nzb+1:nzt-1,nyn+1,nxl:nxr) = nest_offl%w_north(0,nzb+1:nzt-1,nxl:nxr)
-             IF ( .NOT. neutral )  pt(nzb+1:nzt,nyn+1,nxl:nxr) =               &
-                                      nest_offl%pt_north(0,nzb+1:nzt,nxl:nxr) 
-             IF ( humidity      )  q(nzb+1:nzt,nyn+1,nxl:nxr)  =               &
-                                      nest_offl%q_north(0,nzb+1:nzt,nxl:nxr)
-             IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-                DO  n = 1, UBOUND( chem_species, 1 )
-                   IF( nest_offl%chem_from_file_n(n) )  THEN
-                      chem_species(n)%conc(nzb+1:nzt,nyn+1,nxl:nxr) =          &
-                                      nest_offl%chem_north(0,nzb+1:nzt,nxl:nxr,n)
+                   IF( nest_offl%chem_from_file_t(n) )  THEN
+                      chem_species(n)%conc(nzt+1,nys:nyn,nxl:nxr) = nest_offl%chem_top(0,1,1,n)
                    ENDIF
                 ENDDO
@@ -2159,5 +3112,4 @@
 !--    generator correctly. 
        CALL nesting_offl_calc_zi
-       
 !
 !--    After boundary data is initialized, ensure mass conservation. Not 
